#!/usr/bin/env python

#  
#  Copyright (C) 2010 Eugeny Pankov <john.pankov@gmail.com>
#
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
# 
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
# 
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

import atexit
import gobject
import dbus
import dbus.glib
import glib
import sys
import os
import subprocess

try:
    from dockmanager.dockmanager import DockManagerItem, DockManagerSink
    from signal import signal, SIGTERM
    import gconf
    from sys import exit
except ImportError, e:
    exit()

class TerminalItem(DockManagerItem):
    profiles = {'Default' : 'Default'}
    
    def __init__(self, sink, path):
        DockManagerItem.__init__(self, sink, path)
        client = gconf.client_get_default()
        self.add_menu_item('Default', 'gnome-terminal', 'Profiles')
        
        try:
            for i in range(0, 999):
                client.add_dir('/apps/gnome-terminal/profiles/Profile%i' % i, gconf.CLIENT_PRELOAD_NONE)
                name = client.get_string('/apps/gnome-terminal/profiles/Profile%i/visible_name' % i)
                if name is None: break
                self.profiles[name] = 'Profile%i' % i
                self.add_menu_item(name, 'gnome-terminal', 'Profiles')
        except:
            pass

    def menu_pressed(self, menu_id):
        subprocess.Popen(['/usr/bin/gnome-terminal', '--profile=' + self.id_map[menu_id]])
	        
class TerminalSink(DockManagerSink):
    def item_path_found(self, pathtoitem, item):
        if item.Get('org.freedesktop.DockItem', 'DesktopFile', dbus_interface='org.freedesktop.DBus.Properties').endswith('gnome-terminal.desktop'):
            self.items[pathtoitem] = TerminalItem(self, pathtoitem)

terminalsink = TerminalSink()

def cleanup ():
    terminalsink.dispose ()

if __name__ == '__main__':
    mainloop = gobject.MainLoop(is_running=True)

    atexit.register (cleanup)
    signal(SIGTERM, lambda signum, stack_frame: exit(1))

    mainloop.run()
